leetcode40_组合总和 2--回溯法

给定一个数组 candidates 和一个目标数 target ,找出 candidates 中所有可以使数字和为 target 的组合。

candidates 中的每个数字在每个组合中只能使用一次。

说明:

  • 所有数字(包括目标数)都是正整数。
  • 解集不能包含重复的组合。 

示例 1:

输入: candidates = [10,1,2,7,6,1,5], target = 8,
所求解集为:
[
  [1, 7],
  [1, 2, 5],
  [2, 6],
  [1, 1, 6]
]

示例 2:

输入: candidates = [2,5,2,1,2], target = 5,
所求解集为:
[
  [1,2,2],
  [5]
]

思路:

和前一个相比 每个数字只能用一次  所以递归的时候 从当前位置的下一个位置递归

而这次的数组元素可能有重复的  所以组成的list可能重复  得有去重处理

贴代码:

//和之前相比每个数字只能用一次
	public static List<List<Integer>> combinationSum(int[] candidates, int target) {
		List<List<Integer>> res = new ArrayList<List<Integer>>();
		ArrayList<Integer> list=new ArrayList<>();
		if (candidates == null || candidates.length == 0)
			return res;
		Arrays.sort(candidates);
		// 回溯递归
		backtrack(candidates,  0,target, res, list);
		return res;
	}

	
	public static void backtrack(int[] arr, int start, int target, List<List<Integer>> res, ArrayList<Integer> list) {
		if (target < 0)
			return;
		//因为这次的数组元素可能有重复的  所以组成的list可能重复
		if (target == 0) {
			if (!res.contains(list)) {
				res.add(list);
			}		
			return;
		}
		// 加上target >= nums[i]
		for (int i = start; i < arr.length && target >= arr[i]; i++) {
			list.add(arr[i]);
			backtrack(arr, i+1, target - arr[i], res, new ArrayList<Integer>(list));  //从下一个位置递归 i+1
			list.remove(list.size() - 1);
		}
	}
	

猜你喜欢

转载自blog.csdn.net/qq_41864967/article/details/84837737